/*
 *	fram.c
 *
 *	SUPERVISION/EMU
 *
 *	* Fri Apr 15 05:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

/* %r1 w65c02_read(%r0) */
asm("
	.code
	.align	1
	.global	w65c02_read
w65c02_read:
	xcmp	%r0, 0x2000		; $0000-$1FFF: RAM
	xjrlt	_ram_read
	xcmp	%r0, 0x4000		; $2000-$3FFF: Register
	xjrlt	_reg_read
	xcmp	%r0, 0x8000		; $4000-$5FFF: VRAM, ($6000-$7FFFR/WsłAȒP̂߂VRAMɊ܂߂Ă܂܂)
	xjrlt	_ram_read
	xcmp	%r0, 0xc000		; $8000-$BFFF: ROM bank
	xjrlt	_ROM_BANK_read
	; /** FALLTHRU */		; $C000-$FFFF: ROM $C000-$FFFF fix
_rom_read:
	ext	rom@ah
	ext	rom@al
	ld.ub	%r1, [%r0]
	ret
_ram_read:
	ext	ram@ah
	ext	ram@al
	ld.ub	%r1, [%r0]
	ret
_reg_read:
	xcall	w65c02_leave
	xcall.d	reg_read
	ld.w	%r12, %r0		; %r12 <- %addr
	xjp.d	w65c02_enter
	ld.w	%r1, %r10		; %r10 -> %data
_ROM_BANK_read:
	xld.w	%r9, [ROM_BANK]
	add	%r9, %r0
	ld.ub	%r1, [%r9]
	ret
");

/* void w65c02_write(%r0, %r1) */
asm("
	.code
	.align	1
	.global	w65c02_write
w65c02_write:
	xcmp	%r0, 0x2000		; $0000-$1FFF: RAM
	xjrlt	_ram_write
	xcmp	%r0, 0x4000		; $2000-$3FFF: Register
	xjrlt	_reg_write
	xcmp	%r0, 0x8000		; $4000-$5FFF: VRAM ($6000-$7FFFR/WsłAȒP̂߂VRAMɊ܂߂Ă܂܂)
	xjrlt	_ram_write
	ret				; $6000-$FFFF: ROM
_ram_write:
	ext	ram@ah
	ext	ram@al
	ld.b	[%r0], %r1
	ret
_reg_write:
	xcall.d	w65c02_leave
	ld.w	%r12, %r0		; %r12 <- %addr
	xcall.d	reg_write
	ld.w	%r13, %r1		; %r13 <- %data
	xjp	w65c02_enter
");

